// LICENSE : MIT
"use strict";
//  * @param {{foo: ?number, bar: string}} x - this is object param.
//  * @param {{foo, bar}} x - this is object param.

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RecordType = RecordType;

var _Expression = require("./Expression");

/**
 * @return {string}
 */
function RecordType(tag, CodeGenerator) {
    var fields = tag.type.fields;
    var isFiledType = function isFiledType(filed) {
        return filed.type === "FieldType";
    };
    // It is {{}}-self
    var recordTypeAssertion = "typeof " + tag.name + " !== \"undefined\"";
    // These are {{ xxx }}
    var propertyAssertions = fields.filter(isFiledType).map(function (field) {
        var fieldPath = tag.name + "." + field.key;
        return (0, _Expression.Expression)(fieldPath, field.value);
    });
    // join &&
    var expression = [recordTypeAssertion].concat(propertyAssertions).join(" && ");
    return CodeGenerator.assert(expression);
}
//# sourceMappingURL=RecordType.js.map