// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.RestType = RestType;

var _Expression = require("./Expression");

// @param {...number} tag

/*
 {
  title: 'param',
  description: 'this is spread param.',
  type:
   { type: 'RestType',
     expression:
     {
        type: 'NameExpression', name: 'number'
     }
  },
  name: 'x' }
 */
/**
 * @param tag
 * @param CodeGenerator
 * @returns {undefined|string}
 */
function RestType(tag, CodeGenerator) {
    var expectedType = tag.type.expression.name;
    if (tag.type.type !== "RestType") {
        return;
    }
    var expression = tag.type.expression;
    if ((typeof expression === "undefined" ? "undefined" : _typeof(expression)) === "object") {
        var createGenericsAssert = function createGenericsAssert() {
            // or
            var expectedType = (0, _Expression.Expression)("item", expression);
            // Array.<String,Number>
            // => (String || Number)
            return "function(item){ return (" + expectedType + "); }";
        };
        var expressionString = tag.name + ".every(" + createGenericsAssert() + ")";
        return CodeGenerator.assert("Array.isArray(" + tag.name + ") && " + expressionString);
    }
}
//# sourceMappingURL=RestType.js.map