// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.TypeApplication = TypeApplication;

var _Expression = require("./Expression");

// @param {Array.<string>}
/**
 * @return {string|undefined}
 */
function TypeApplication(tag, CodeGenerator) {
    var expectedType = tag.type.expression.name;
    if (expectedType === "Array") {
        var _ret = function () {
            var applications = tag.type.applications;
            if (applications) {
                var createGenericsAssert = function createGenericsAssert() {
                    // or
                    var expressions = applications.map(function (application) {
                        return (0, _Expression.Expression)("item", application);
                    });
                    // Array.<String,Number>
                    // => (String || Number)
                    var expression = expressions.join(" || ");
                    return "function(item){ return (" + expression + "); }";
                };
                var expression = tag.name + ".every(" + createGenericsAssert() + ")";
                return {
                    v: CodeGenerator.assert("Array.isArray(" + tag.name + ") && " + expression)
                };
            } else {
                return {
                    v: CodeGenerator.assert("Array.isArray(" + tag.name + ")")
                };
            }
        }();

        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
    }
}
//# sourceMappingURL=TypeApplication.js.map